
$1=="p" {
# $3 is number of variables
# $4 is number of clauses
  print "<owl:Class> "
  print "  <owl:oneof rdf:parseType='Collection'>"
  for (i=1;i<=$4;i++) {
  print "     <owl:Thing rdf:ID='cl" i "'/>"
  }
  print "  </owl:oneof>"
  print "  <rdfs:subClassOf>"
  print "     <owl:Class rdf:ID='T'/>"
  print "  </rdfs:subClassOf>"
  print "</owl:Class>"
  for (i=1;i<=$3;i++) {
    print "<owl:Class rdf:ID='t" i "'>"
    print "  <owl:intersectionOf rdf:parseType='Collection'>"
    print "     <owl:Class>"
    print "       <owl:oneof rdf:parseType='Collection'>"
    print "         <owl:Thing rdf:about='#plus" i "'>"
    print "            <owl:differentFrom rdf:resource='#minus" i "'/>"
    print "         </owl:Thing>"
    print "         <owl:Thing rdf:about='#minus" i "'/>"
    print "       </owl:oneof>"
    print "     </owl:Class>"
    print "     <rdf:Description rdf:about='#T'/>"
    print "  </owl:intersectionOf>"
    print "  <owl:oneof rdf:parseType='Collection'>"
    print "       <owl:Thing rdf:ID='tt" i "'>"
    print "  </owl:oneof>"
    print "</owl:Class>"
  }
}
$4=="0" {
   c = NR-2
   print "<rdf:Description rdf:about='cl"  c "'>"
   print "   <rdf:type>"
   print "      <owl:Class>"
   print "        <owl:oneof rdf:parseType='Collection'>"
   pvar($1)
   pvar($2)
   pvar($3)
   print "        </owl:oneof>"
   print "      </owl:Class>"
   print "   </rdf:type>"
   print "</rdf:Description>"
}

func pvar(i) {
  print "            <rdf:Description rdf:about='#" (i>0? "plus" i : "minus" (-i)) "'/>"
}
