/*
 * Issue.java
 *
 * Created on 19 September 2002, 05:30
 */

package wowg;

import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.vocabulary.RDFS;
/**
 *
 * @author  jjc
 */
public class Feature {
    Resource res;
    /** Creates a new instance of Issue */
    public Feature(Resource r) {
        res = r;
    }
    public String getName() {
        try {
            return res.getProperty(RDFS.label).getString();
        }
        catch (RDFException e) {
            return HasErrors.getFragment(res.getURI());
        }
    }
    public boolean equals(Object o) {
        return o != null && o instanceof Issue && ((Issue)o).res.equals(res);
    }
    public int hashCode() {
        return res.hashCode();
    }
    
}
