/*
 * HasErrors.java
 *
 * Created on 15 September 2002, 20:23
 */

package wowg;
import java.util.*;

/**
 *
 * @author  jjc
 */
public class HasErrors {
    
    /** Creates a new instance of HasErrors */
    public HasErrors() {
    }
    private Vector errors = new Vector();
    
    public String getErrors() {
        String rslt = "";
        Iterator it = errors.iterator();
        while ( it.hasNext() ) {
            rslt += (String)it.next()+"\n<br />\n";
        }
        return rslt;
    }
    void clearErrors() {
        errors = new Vector();
    }
    void addError(String err) {
    	if (!errors.contains(err))
         errors.add(err);
    }
    void addError(Exception e) {
        addError(e.getMessage());
        e.printStackTrace();
    }
    String getFilename(String url) {
        int ix = url.lastIndexOf('/')+1;
        if ( ix == url.length() )
            ix = url.lastIndexOf('/',ix-2)+1;
        return "<a href=\"" + url + "\">"+url.substring(ix)+"</a>";
    }
    static String getFragment(String s) {
        return s.substring(s.lastIndexOf('#')+1);
    }
    void mergeErrors(HasErrors x) {
        errors.addAll(x.errors);
    }
    
}
