/*
 * Testy.java
 *
 * Created on 21 September 2002, 17:47
 */

package wowg;
import com.hp.hpl.jena.rdf.model.Resource;

/**
 *
 * @author  jjc
 */
abstract public class Testy extends HasErrors {
    
   
    static String escape(final String txt) {
    //    System.err.println(txt);
        if ( txt == null ) {
            new NullPointerException().printStackTrace();
            return "Null pointer Error here";
    }
        StringBuffer buf = new StringBuffer();
       // final String str = "&lt;";
        int lg = txt.length();
        for (int i=0; i<lg; i++) {
            char ch = txt.charAt(i);
            if (ch=='<') {
                // can't remember why I wanted to avoid &lt;
                buf.append('&');
                buf.append('l');
                buf.append('t');
                buf.append(';');
            } else if ( ch=='&' ) {
                buf.append('&');
                buf.append('a');
                buf.append('m');
                buf.append('p');
                buf.append(';');
            }else if ( ch > 128 ) {
                buf.append('&');
                buf.append('#');
                buf.append(""+((int)ch));
                buf.append(';');
            } else
                buf.append(ch);
        }
        
     //   System.err.println(buf.toString());
      //  System.err.flush();
        return buf.toString();
    }
   // abstract void foo();
   // abstract public boolean getTwoFile();
    
    abstract public String getAuthor();
    abstract public String getTestType();
    abstract public String getName();
    abstract public String getDescription();
    abstract public Triples asTriples();
    abstract public Resource getSize();
    abstract public int getN();
    abstract public String getFileHeading(int i);
  //  abstract public String getSecondFileHeading();
   abstract public String getFile(int i);
   abstract Resource getLevelR();
   abstract Resource getLevelR(int i);
   private String convertLevel(Resource r) {
       if ( r == null ) {
           addError("Missing level declararion.");
           return "?";
       }
       return r.getLocalName();
       
   }
   public String getLevel() {
       
       return convertLevel(getLevelR());
   }
   public String getLevel(int i) {
       if ( i >= getN() )
           return "";
       return convertLevel(getLevelR(i));
   }
  
    abstract public String getURI(int i);
    abstract public String getTestURI();
    public String getFileEscaped(int i){
        return escape(getFile(i));
    }
   
    public String getDescriptionAsString() {
        String orig = getDescription();
        String rslt = "";
        int tag;
        int pos = 0;
        int lngth = orig.length();
        while ( true ) {
           tag = orig.indexOf("<",pos);
           if ( tag == -1 ) {
               rslt += orig.substring(pos,lngth);
               break;
           }
           rslt = rslt + orig.substring(pos,tag);
           pos = orig.indexOf(">",tag);
           if ( pos == -1 ) {
               addError("Strange formatting in \"" + orig + "\"");
               break;
           }
           pos += 1;
        }
        return rslt.replace('\n',' ');
    }
}
