<%@page contentType="text/html"
   import="java.util.zip.*"
   import="java.util.*"
   import="wowg.*" 
   import="java.io.*"
   import="com.hp.hpl.jena.rdf.model.*"
   autoFlush="true"
%>
<% String submit = Zipper.getParameter(request,"submit");
   Zipper zipper = new Zipper(request);
   if (submit.startsWith("Zip")) {
        out.clear();
        response.setContentType("application/zip");
        zipper.zip(response.getOutputStream());
        out.close();
        return;
     //response.sendRedirect("test.zip");
     //out.clear();
     //out.close();
   } 
    if ( submit.startsWith("Refresh") ) {
         zipper.refresh();
    }
    if ( submit.startsWith("Boiler") ) {
          zipper.boiler();
      }
     Iterator it;
     int ii;
%>

<html>
  <head>
    <title> WebOnt WG: Test Case Editor </title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
  </head>
  <body>
    <h1>
     WebOnt WG: Test Case Editor</h1>
<%String errorMsg = zipper.getErrors();
  if (errorMsg.length()>0 ) { %>
<hr/>
<p style="color: red;">
<em><%=errorMsg%></em>
</p>
<hr/>
<% } %>
<%
    if ( submit.startsWith("Validate") ) {
          Testy test = zipper.validate();
          boolean showRDFXML = true;
          boolean showTriples = true;
          boolean areNormative = true;
          boolean suppress = false;
          int size = 1;
          String testTag="foo";
          String outerAnchor="none";
          Set simpleAnchors = new HashSet();
          boolean editorsDraft = true;
%> 
<%@include file="tests4.jsp"%>
<%
      }
%>
    <p>Please use this form to create and edit OWL test cases.
It is currently restricted to ASCII.
    </p>
    
    <form method="post" action="edit.jsp"
accept-charset = "utf-8"
      <%-- enctype="multipart/form-data" --%>
       >
<hr>
<p>Enter one of:</p>
<ul>
      <li>Test feature:

      <select name='feature'>
        <option value="">no feature</option>
<% it = Manifest.loader.features();
   while ( it.hasNext() ) {
     Feature f = (Feature)it.next();
%>
        <option <%=zipper.feature.equals(f.getName())?"selected":""%>><%=f.getName()%></option> 
<% } %>
     </select>
      </li>
      <li>Test issue:
      <select name='issue'>
        <option value="">no issue</option>
<% it = Manifest.loader.issues();
   while ( it.hasNext() ) {
     Issue f = (Issue)it.next();
     String issuex = f.getFragment();
%>
        <option <%=zipper.issue.equals(issuex)?"selected":""%>
                value="<%=issuex%>" ><%=f.getNumber()%> <%=f.getName()%></option> 
<% } %>
     </select>
      </li>
<li>
<table>
<tr>
<th><input type="radio" name="section" value="misc"
  <%=zipper.section.equals("misc")?"checked":""%>
>Miscellaneous</input></th>
<th><input type="radio" name="section" value="dl"
  <%=zipper.section.equals("dl")?"checked":""%>
>DL</input></th>
<th><input type="radio" name="section" value="extra"
  <%=zipper.section.equals("extra")?"checked":""%>
>Extra Credit</input></th>
</tr>
<tr>
<td>
      <select name='miscSubSection'>
        <option value=''>new sub-section</option>
<%  Iterator ri;
  String uri;
  ri = Manifest.issuettes("misc");
  while ( ri.hasNext() ) {
     uri = ((Resource)ri.next()).getURI();
%>
  <option <%=uri.endsWith("#"+zipper.miscSubSection)?"selected":""%> value="<%=uri.substring(31)%>" ><%=uri.substring(40)%></option>
<% } %>
      </select>
</td>
<td>
      <select name='dlSubSection'>
        <option value=''>new sub-section</option>
<% ri = Manifest.issuettes("dl");
  while ( ri.hasNext() ) {
     uri = ((Resource)ri.next()).getURI();
%>
  <option <%=uri.endsWith("#"+zipper.dlSubSection)?"selected":""%> value="<%=uri.substring(31)%>" ><%=uri.substring(38)%></option>
<% } %>
      </select>
</td>
<td>
      <select name='extraSubSection'>
        <option value=''>new sub-section</option>
<% ri = Manifest.issuettes("extra");
  while ( ri.hasNext() ) {
     uri = ((Resource)ri.next()).getURI();
%>
  <option <%=uri.endsWith("#"+zipper.extraSubSection)?"selected":""%> value="<%=uri.substring(31)%>" ><%=uri.substring(41)%></option>
<% } %>
      </select>
</td>
</tr>
</table>
<br /> 
New subsection tag: 
        <input type="text" size="30" name="newSubSection" value="<%=zipper.newSubSection%>"/>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Start test:
      <select name='start'>
<% for (ii=0; ii<10;ii++) {
          String ss = ii+"00";
%><option <%=ss.equals(zipper.start)?"selected":""%> ><%=ss%></option>
<%}%>
     </select>
</li>
</ul>
      <p>Test number:
      <select name='number'>
<%  String matchNumber;
    switch ( zipper.number.length() ) {
       case 3:
         matchNumber = "N"+ zipper.number.substring(1);
         break;
       default:
         matchNumber = "N"+ zipper.number;
    }
    for (ii=1; ii<21;ii++) {
          String ss = (ii<10)?("N0"+ii):("N"+ii);
%><option <%=ss.equals(matchNumber)?"selected":""%> value="<%=ss.substring(1)%>"><%=ss%></option>
<%}%>
     </select>
      </p>
      <p>To edit an existing test, select it and then press here.
      </p>
<P>
     <input type="submit" name="submit"  value="Refresh from www.w3.org" />
</P>
<hr>
      <p>Test author:
<%  String authors[] = Manifest.authors();
%>
      <select name='author1' tabindex='10'>
        <option label='not listed'  value=''>select your name, if listed</option>
<% for (int aCnt=0; aCnt<authors.length; aCnt++) {
%>
  <option <%=authors[aCnt].equals(zipper.author1)?"selected":""%> ><%=authors[aCnt]%></option>
<% } %>
      </select></p>
    <p>Test author (unlisted - first time):

        <input type="text" size="30" name="author2" value="<%=zipper.author2%>"/>
    </p>
    <p>Approval - enter URL of minutes:
        <input type="text" size="30" name="approval" value="<%=zipper.approval%>"/>
    </p>
<hr/>
      <p>Test type:
      <select name='testType'>
<% it = TestType.all();
   while ( it.hasNext() ) {
     TestType f = (TestType)it.next();
%>
        <option <%=zipper.testType.equals(f.getName())?"selected":""%> ><%=f.getName()%></option> 
<% } %>
      </select></p>

<P>
   After selecting the test type, you can intialize a new test with 
useful boiler plate.
     <input type="submit" name="submit"  value="Boiler plate" />
</P>

      <p>Level of entailment:
      <select name='entailmentLevel'>
<%=zipper.levels(zipper.entailmentLevel)%>
      </select>&nbsp;Size of test (<%=zipper.size%>):<select name='size'>
<%=zipper.sizes(zipper.size)%>
      </select></p>
      <p>Test Description:<br />
<textarea name="description" rows="4" cols="75"><%=zipper.description%></textarea>
      </p>      
<p>Premises/consistent/inconsistent/illegal/true file:<br />
      Level of file:
      <select name='firstLevel'>
<%=zipper.levels(zipper.firstLevel)%>
      </select><br />
<textarea name="first" rows="20" cols="100"><%=zipper.first%></textarea>
</p>
<p>Conclusion/Nonconclusions:<br />
      Level of file:
      <select name='secondLevel'>
<%=zipper.levels(zipper.secondLevel)%>
      </select><br />
<textarea name="second" rows="20" cols="100"><%=zipper.second%></textarea>
</p>
<P>
Please either:
</P>
<ul>
<li>
     <input  type="submit" name="submit"  value="Validate test" />
<li>
     <input  type="submit" name="submit"  value="Zip up test" /> 
</ul>
Then please e-mail the zipped test to:
<a href="mailto:jos">Jos De Roo</a>.
</P>
    </form>
    <hr />
<%--
<% } else { %> <%-- wantZip -- %>

<%!
String hidden(String name, ServletRequest req) {
   String v = req.getParameter(name);
   if ( v == null ) 
       return "";
   StringBuffer rslt = new StringBuffer("<input type=\"hidden\" name=\"" + name + "\" value=\"");
   for (int i=0;i<v.length();i++) {
          char ch = v.charAt(i);
          if (ch<127 && ch > 32 ) {
              switch ( ch ) {
                   case '<':
                   case '&':
                   case '"':
                     break;
                   default:
                     rslt.append(ch);
                     continue;
              }
          }
          rslt.append("&#"+(int)ch+";");
   }
   rslt.append("\"/>");
   return rslt.toString();
}
%>

    <form method="post" action="test.zip"
      <%-- enctype="multipart/form-data" -- %>
accept-charset = "utf-8"
       >
  <%=hidden("feature",request)%>
  <%=hidden("issue",request)%>
  <%=hidden("number",request)%>
  <%=hidden("author1",request)%>
  <%=hidden("author2",request)%>
  <%=hidden("type",request)%>
  <%=hidden("description",request)%>
  <%=hidden("first",request)%>
  <%=hidden("second",request)%>
   <input  type="submit" name="submit"  value="last click for zip" />

   </form>
--%>

  </body>
</html>
