<?xml version="1.0" encoding="iso-8859-1"?>
<%@page contentType="text/html"
  import="java.util.*"
  import="java.io.*" 
  import="wowg.*"
  import="com.hp.hpl.jena.rdf.model.*" 

%>
<% boolean editorsDraft = !Zipper.getParameter(request,"editorsDraft").equals("false");
   String sz = Zipper.getParameter(request,"size");
   int size = sz.startsWith("X") ? 2 : sz.startsWith("M") ? 0 : 1 ;
  GregorianCalendar cal = editorsDraft?new GregorianCalendar():new GregorianCalendar(2003,2,31);
%>
<%!boolean w3cIsDown = false;
   String months[] = {
"January",
"February",
"March", 
"April", 
"May",
"June",
"July",
"August",
"September",
"October",
"November",
"December"
};
static String format10(int i) {
 return i<10? ("0"+i):(""+i);
}
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html lang="en" xmlns="http://www.w3.org/1999/xhtml" >
<head>
<meta http-equiv="Content-Type" 
content="text/html; charset=iso-8859-1" />
 
  <meta name="rcsid"
  content="$Id: main.jsp,v 1.43 2003/04/19 05:29:59 jcarroll Exp $"  />

<title>OWL Web Ontology Language Test Cases</title> 
 
  <style type="text/css">

.Foo {
}

.TestTable {
  page-break-inside: avoid;
}
 .TestType {
    background-color: #d3d3d3;
    color: black;
 }  
.TestNumber {
    background-color: #d3d3d3;
    color: black;
 }
.TestDescriptionHead {
    background-color: #e8e8e8;
    color: black;
 }
.TestErrorsHead {
    background-color: #e8e8e8;
    color: black;
 }
.TestNamespacesHead {
    background-color: #e8e8e8;
    color: black;
 }
.TestPartHead {
    background-color: #e8e8e8;
    color: black;
 }
 .TestDescription {
    background-color: #ffec8b;
    color: black;
 }  
 .TestTriples {
    background-color: #85b9a5;
    color: black;
 }  
 .TestNamespaces {
    background-color: #85b9a5;
    color: black;
 } 
 .TestRDF {
    background-color: #c8c8f8;
    color: black;
 } 

.TestErrors {
    background-color: #ffe8e8;
    color: red;
 }
  .TestRDF pre {
    margin-left: 0em;
    margin-top: 0em;
    margin-bottom: 0em;
    font-family: monospace;
  }
  .TestTriples pre {
    margin-left: 0em;
    margin-top: 0em;
    margin-bottom: 0em;
    font-family: monospace;
  }
  .TestNamespaces pre {
    margin-left: 0em;
    margin-top: 0em;
    margin-bottom: 0em;
    font-family: monospace;
  }


.note  { margin-left: 2em; }

*.todo {
  color: red;
  font-style: italic; 
}

*.conformance {
  color: #850021;
  font-weight: bold;
  font-style: italic;
}

  </style>
<% if (! w3cIsDown ) { %>
<link rel="stylesheet" type="text/css"
 href="http://www.w3.org/StyleSheets/TR/W3C-WD" />
<% } %>
</head>
<body>
<div class="head"><a href="http://www.w3.org/">
<% if (! w3cIsDown ) { %>
<img height="48"
width="72" alt="W3C" src="http://www.w3.org/Icons/w3c_home" /> 
<% } %>
</a>

<h1><a name="title" id="title">OWL Web Ontology Language <br /> Test Cases</a></h1>

<h2><a name="WD" id="WD"><%=editorsDraft?"Editors":"W3C"%> Working Draft 
<%=format10(cal.get(Calendar.DAY_OF_MONTH))%>
<%=months[cal.get(Calendar.MONTH)]%>
<%=cal.get(Calendar.YEAR)%></a>
</h2>
 
<dl>


<dt>This version:</dt>
<%if (editorsDraft) { %>
<dd>No URI</dd> 
<dt>Latest editors snapshot:</dt>
<dd><a href="http://www.w3.org/2002/03owlt/editors-draft/draft/">http://www.w3.org/2002/03owlt/editors-draft/draft/</a></dd>
<%} else {
String versionURI="http://www.w3.org/TR/" 
+ cal.get(Calendar.YEAR)
+ "/WD-owl-test-"
+ cal.get(Calendar.YEAR)
+ format10(cal.get(Calendar.MONTH)+1)
+ format10(cal.get(Calendar.DAY_OF_MONTH)) + "/";

%>

<dd><a href="<%=versionURI%>"><%=versionURI%></a></dd>
<%}%>
<dt>Latest version:</dt>

<dd><a href="http://www.w3.org/TR/owl-test/">http://www.w3.org/TR/owl-test/</a></dd>

<dt>Previous version:</dt>

<dd><a href="http://www.w3.org/TR/2003/WD-owl-test-20030331/">http://www.w3.org/TR/2003/WD-owl-test-20030331/</a></dd>



<dt>Editors:</dt>

    <dd><a href="http://www-uk.hpl.hp.com/people/jjc/">Jeremy J. Carroll</a>, HP
      &lt;<a href="mailto:jjc@hpl.hp.com">jjc@hpl.hp.com</a>&gt;</dd>
    <dd>
<a href="http://www.agfa.com/w3c/jdroo/">Jos De Roo</a>, AGFA,&lt;<a
      href="mailto:jos.deroo@agfa.com">jos.deroo@agfa.com</a>&gt;</dd>
</dl>


  <p>
This document is available in three sizes: 
<a href="M">medium</a> (non-normative<%=size==0?", this version":""%>), 
<a href="./">large</a> (normative<%=size==1?", this version":""%>),
and <a href="XXL">extra large</a> (non-normative<%=size==2?", this version":""%>).
The tests of this document are also available in these non-normative formats:
  <a href="approved.zip">Zip archive of approved tests</a>, <a
href="proposed.zip">Zip archive of proposed tests</a>, <a
href="http://www.w3.org/2002/03owlt/">the test web site</a>. </p>

<p class="copyright">
<a href="http://www.w3.org/Consortium/Legal/ipr-notice#Copyright">
Copyright</a> &#xa9; 2003 <a href="http://www.w3.org/">
<acronym title="World Wide Web Consortium">W3C</acronym></a><sup>&#xae;</sup>
(<a href="http://www.lcs.mit.edu/"><acronym title="Massachusetts
Institute of Technology">MIT</acronym></a>, <a
href="http://www.ercim.org/"><acronym title="European Research
Consortium for Informatics and Mathematics">ERCIM</acronym></a>, <a
href="http://www.keio.ac.jp/">Keio</a>), All Rights Reserved. W3C <a
href="http://www.w3.org/Consortium/Legal/ipr-notice#Legal_Disclaimer">
liability</a>,
<a href="http://www.w3.org/Consortium/Legal/ipr-notice#W3C_Trademarks">
trademark</a>,
<a href="http://www.w3.org/Consortium/Legal/copyright-documents">document
use</a> and 
<a href="http://www.w3.org/Consortium/Legal/copyright-software">software
licensing</a> rules apply.
</p>  


<hr />
</div>

<h2><a id="abstract" name="abstract">Abstract</a></h2>
<p>
This document contains and presents test cases for the Web Ontology Language (OWL)
approved by the
Web Ontology Working Group. Many of the test cases illustrate the correct usage
of the Web Ontology Language (OWL), and the formal
meaning of its constructs. Other test cases 
illustrate the resolution of issues considered by the working group.
Conformance for OWL documents and OWL document checkers is specified.
</p>

<% synchronized ( this ) { 
   refs = new HashSet();
%>
<%if (editorsDraft) { %>
<p>
<strong>Status below is fictitious.</strong>
</p>
<% } %>
<h2><a id="status" name="status">Status of this document</a></h2>


<p><em>This section describes the status of this document at the time of its publication. 
ther documents may supersede this document. The latest status of this document series is maintained at the
W3C.</em></p>

<p>
<%--
This is the <a href="http://www.w3.org/Consortium/Process-20010719/tr.html#last-call">Last Call Working Draft</a> of
 "OWL Test Cases" for review by members of the W3C and
other interested parties in the general public.
The Last Call review is intended primarily to review the text of this document.
--%>
This is a Working Draft of "OWL Test Cases" for review by members of the W3C
and other interested parties in the general public. 
We particular seek reports from implementators  concerning
both
errors in the tests and successful execution of these tests, 
both proposed and approved.
The tests are still in development. 
<%-- and are
being changed. during the last call review period,
up to the publication of the corresponding
<a href="http://www.w3.org/Consortium/Process-20010719/tr.html#RecsPR">Proposed Recommendation</a>.
--%>

Each test
may be edited or have a change of status  according to
the <a href="#testProcess">process specified below</a>.
Further tests are being added.
Reviewers should note in particular that the syntactic levels indicated
with each test file (Lite, DL, Full) have <em>never</em> been validated,
and have <em>not</em> been updated in light of recent working group decisions.

An editors' version of this document, with the latest tests, can be found at
<a href="http://www.w3.org/2002/03owlt/editors-draft/draft/">http://www.w3.org/2002/03owlt/editors-draft/draft/</a>.
Other expected changes are indicated by <span class="todo">editors' notes</span>, and in 
<a href="#editorialIssues">Appendix D</a>.
Despite this flux, the working group would value
implementor feedback on the tests both in this document and those found in
the editors' version.
Contributions of additional tests are invited.
<%--
 The Last Call review period ends <span class="todo">???</span> 2003
--%>
</p>
<p>This document is subsidiary to the normative
 definition of the Web Ontology Language 
<%=ref("OWL Semantics and Abstract Syntax")%>).
</p>

<p>Publication as a Working Draft does not imply endorsement by the W3C Membership. This is a draft document and may be updated, replaced or obsoleted by other documents at any time. It is
inappropriate to cite this document as other than "work in progress". <a href="http://www.w3.org/TR/">A list of current W3C Recommendations</a> and other technical documents can be found at
<span>http://www.w3.org/TR</span>.</p>

<p>Patent disclosures relevant to this specification may be found on the Working Group's public 
<a rel="disclosure"
    href="http://www.w3.org/2001/sw/WebOnt/discl">patent disclosure page</a>.</p>


<p>Comments on this document should be sent to
<a
href="mailto:public-webont-comments@w3.org">public-webont-comments@w3.org</a>,
a mailing list with a
<a
href="http://lists.w3.org/Archives/Public/public-webont-comments/">public
archive</a>.
General discussion of related technology is welcome in
<a href="mailto:www-rdf-logic@w3.org">www-rdf-logic@w3.org</a> 
(<a
href="http://lists.w3.org/Archives/Public/www-rdf-logic/">archive</a>).
</p>


<p>This document has been produced as part of the <a
href="http://www.w3.org/2001/sw/">W3C Semantic Web Activity</a> (<a
href="http://www.w3.org/2001/sw/Activity">Activity Statement</a>)
following the procedures set out for the
<a href="http://www.w3.org/Consortium/Process/Process-19991111/">W3C
Process</a>. The document has been written by the
<a href="http://www.w3.org/2001/sw/WebOnt/">Web Ontology Working
Group</a>. The goals of the Web Ontology working group are
discussed in the
<a href="http://www.w3.org/2001/sw/WebOnt/charter">Web Ontology
Working Group charter</a>.
</p>

<hr />


<%! String named(String foo) {
      return "<code>"+foo +"<em>NNN</em>.rdf</code>";
    }
%>
<%String pattern = request.getParameter("pattern");
   Manifest approved = new Manifest("APPROVED",pattern);
   Manifest proposed = new Manifest("PROPOSED",pattern);%>

<%-- Test --%>

<%!
  boolean toc;
  String tocContent;
  int levels[];
  int lastLevel=-1; 
  int _lvl;
  String _anch;
  String _text;
  int _i;
  int appendix;
%>
 
<%!
   void closeToc(int lvl) {
     if ( lvl == lastLevel+1 ) {
         tocContent += "<ul class=\"toc\">";
          return;
    }
     String c = "</li>";
     for ( int j = lastLevel; j>lvl;j--)
       c = c + "</ul></li>";
     tocContent += c;
   }
   String head(int lvl,String anch,String text) {
      boolean nonumber = lvl == 0;
      lvl--;
      if ( lvl <= lastLevel && lvl >= 0 ) {
       levels[lvl]++;
      } else if ( lvl == lastLevel+1 ) {
        levels[lvl]=1;
     } else if ( lvl == -1 ) {
        lvl = 0;
     } else {
         return "<b>SCREW UP IN HEADER LEVELS: " + lastLevel + "; " + lvl + "</b>";
     }

     if ( toc ) {
       closeToc(lvl);
       lastLevel = lvl;
     String rslt = "<li class=\"tocline\"><a href='#"+anch+"'>";
     if (!nonumber) {
     if ( appendix > 0 )
         rslt += ((char)(levels[0]-appendix + 'A')) + ".";
      else
        rslt += levels[0] + ".";
     for (int i=1; i<=lvl; i++)
       rslt += levels[i]+".";
     }
     rslt += " "+ text + "</a>";

         tocContent += rslt;
        return "";
     } else {
     
     lastLevel = lvl;
     String rslt = "<h" + (lvl+1)+"><a id='"+anch+"' name='"+anch+"'>";
     if (!nonumber) {
     if ( appendix > 0 )
         rslt += ((char)(levels[0]-appendix + 'A')) + ".";
      else
        rslt += levels[0] + ".";
     for (int i=1; i<=lvl; i++)
       rslt += levels[i]+".";
     }
     rslt += " "+ text + "</a></h"+(lvl+1)+">";

     return rslt;
     }
  }

Set refs;
String repl(String s) {
return s.replace(' ','_').replace('/','_').replace('+','_');
}
String ref(String sss) {
   refs.add(sss);
   return "<a href=\"#ref-"+repl(sss)+"\">["+sss+"]</a>";
}
String defref(String sss) {
    String rslt = "<dt><a name=\"ref-"+repl(sss)+"\" id=\"ref-"+repl(sss)+"\" >["
            +sss+"]</a></dt><dd>";
    if ( !refs.contains(sss) ) {
         rslt = rslt + "Not referenced. ";
   } else {
        refs.remove(sss);
   }
   return rslt;
}
String internal(String anch, String sss) {
   return "<a href=\"#"+anch+"\">"+sss+"</a>";
}
%>

<%levels = new int[5];
 lastLevel=-1;
 appendix = -1;
%>



<h2 class="notoc"><a id="toc" name="toc">Table of Contents</a></h2>

<div class="contents">

<%// <ul class="toc">
// Variables used during test case output.
// Setup variables
   Manifest tests;  // The test we select from.
   boolean useRDFXML;  // or NTriple
   boolean byFunction; // or byIssue
   boolean areNormative;
   String prefix;    // used in fragment identifiers
   String testTag = null;   
   Set simpleAnchors = new HashSet();

       boolean showRDFXML;
       boolean showTriples;

// utility variables
   Iterator it;
   Map testsBy;
%>
<%
  //if ( true )
  //{ final PrintWriter out = new PrintWriter(new OutputStreamWriter(new OutputStream(){
  //  public void write(int i) {}
  //}));
 // BodyContext ctxt = pageContext.pushBody();
  out = pageContext.pushBody();

  tocContent = "";
  toc = true;
%>
<%@ include file="body.jsp" %>
<%
  closeToc(0);
  toc = false;
  out = pageContext.popBody();
 // } 
%>
<%=tocContent%>
<%--
<%=ctxt.getString()%>
--%> 
<%levels = new int[5];
 lastLevel=-1;
 appendix = -1;
 simpleAnchors = new HashSet();
%>
</ul>
</div>
<hr /> 


<%@ include file="body.jsp" %>

<% } /* end synchronized block */ %>

    <h2><a name="normative" id="normative">Normative</a></h2>
<dl>


 


 
<%=defref("OWL Semantics and Abstract Syntax")%> 
<cite><a href="http://www.w3.org/TR/2003/WD-owl-semantics-20030331/">OWL Web Ontology Language Semantics and Abstract Syntax</a></cite>.
Peter F. Patel-Schneider, Patrick Hayes, and Ian Horrocks.
W3C Working Draft 03 February 2003.
<a href="http://www.w3.org/TR/owl-semantics/">Latest version</a> is available at <tt>http://www.w3.org/TR/owl-semantics/</tt>.
</dd>
<%--
<%=defref("OWL Language")%>
<cite><a href="http://www.w3.org/TR/2002/WD-owl-ref-20020729/">OWL Web Ontology Language 1.0 Reference</a></cite>.
Mike Dean, Dan Connolly, Frank van Harmelen, James Hendler, Ian Horrocks,
Deborah L. McGuinness, Peter F. Patel-Schneider, and Lynn Andrea Stein.
W3C Working Draft 29 July 2002.
<a href="http://www.w3.org/TR/owl-ref/">Latest version</a> is available at <tt>http://www.w3.org/TR/owl-ref/</tt>.
</dd>
--%>
<%=defref("RFC 2119")%>
<cite><a href="http://www.ietf.org/rfc/rfc2119.txt">
RFC 2119 - Key words for use in RFCs to Indicate Requirement Levels
</a></cite>. S. Bradner, 
IETF. March 1997. This document is <tt>http://www.ietf.org/rfc/rfc2119.txt</tt>. 
</dd>
<%=defref("RDF Concepts")%>
<cite><a href="http://www.w3.org/TR/2003/WD-rdf-concepts-20030123/">
RDF Concepts and Abstract Syntax</a></cite>.
Graham Klyne and Jeremy J. Carroll, eds.
W3C Working Draft 23 January 2003.
Latest version is available at
<a href="http://www.w3.org/TR/rdf-concepts/"><tt>http://www.w3.org/TR/rdf-concepts/</tt></a>.
</dd>
<%=defref("RDF Schema for OWL")%>
<cite><a href="http://www.w3.org/2002/07/owl">
<tt>http://www.w3.org/2002/07/owl</tt></a></cite>.
Mike Dean, ed.
World Wide Web Consortium.
</dd>
<%=defref("RDF/XML Syntax")%>
<cite><a href="http://www.w3.org/TR/2003/WD-rdf-syntax-grammar-20030123/">
RDF/XML Syntax Specification (Revised)</a></cite>.
Dave Beckett, ed.
W3C Working Draft 23 January 2003.
Latest version is available at
<a href="http://www.w3.org/TR/rdf-syntax-grammar/"><tt>http://www.w3.org/TR/rdf-syntax-grammar/</tt></a>.
</dd>


<%=defref("XML Schema Datatypes")%>
<cite><a href="http://www.w3.org/TR/2001/REC-xmlschema-2-20010502/">
XML Schema Part 2: Datatypes.</a></cite>.
Paul V. Biron and Ashok Malhotra, eds.
W3C Recommendation 02 May 2000.
Latest version is available at 
<a href="http://www.w3.org/TR/xmlschema-2/">http://www.w3.org/TR/xmlschema-2/</a>.
</dd>
</dl>
    <h2><a name="informative" id="informative">Informative</a></h2>
<dl>

<%=defref("DAML+OIL")%>
<cite><a href="http://www.w3.org/TR/2001/NOTE-daml+oil-reference-20011218">
DAML+OIL (March 2001) Reference Description</a></cite>.
Dan Connolly, Frank van Harmelen, Ian Horrocks,
Deborah L. McGuinness, Peter F. Patel-Schneider, and Lynn Andrea Stein.
W3C Note 18 December 2001.
Latest version is available at
<a href="http://www.w3.org/TR/daml+oil-reference"><tt>http://www.w3.org/TR/daml+oil-reference</tt></a>.
</dd> 

<%=defref("Dublin Core")%>
<a href="http://dublincore.org/documents/"><tt>http://dublincore.org/documents/</tt></a>

</dd>  
<%=defref("N3")%>
<cite><a href="http://www.w3.org/2000/10/swap/Primer.html">Primer: Getting into RDF &amp; Semantic Web using N3</a></cite>
Tim Berners-Lee, Dan Connolly
</dd>

<%=defref("OWL Guide")%>
<cite><a href="http://www.w3.org/TR/2003/WD-owl-guide-20030331/">
OWL Web Ontology Language 
 Guide</a></cite>.
Michael K. Smith, Chris Welty, Deborah McGuinness, eds.
31 March 2003.
The <a href="http://www.w3.org/TR/owl-guide/">latest version of the OWL Guide</a> is 
at <tt>http://www.w3.org/TR/owl-guide/</tt>.
</dd>
<%=defref("OWL Issues")%>
<cite><a href="http://www.w3.org/2001/sw/WebOnt/webont-issues.html">
Web Ontology Issue Status</a></cite>.
Michael K. Smith, ed.
26 Feb 2003.
</dd>

<%=defref("RDF Test Cases")%>
<cite><a href="http://www.w3.org/TR/2003/WD-rdf-testcases-20030123/">RDF Test Cases</a></cite>, A. Barstow, 
D. Beckett, J. Grant, Editors.  Work in progress.  World Wide Web Consortium, 23 January 2003.  
This version of the RDF Test Cases is <tt>http://www.w3.org/TR/2003/WD-rdf-testcases-20030123/</tt>. 
 The <a href="http://www.w3.org/TR/rdf-testcases/">latest version of the RDF Test Cases</a> is 
at <tt>http://www.w3.org/TR/rdf-testcases/</tt>.
  </dd>
<%=defref("W3C CVS")%>
<cite><a href="http://www.w3.org/Project/CVSdoc/">
Use of CVS in W3C 
</a>
</cite> (member-only link).
Henrik Frystyk Nielsen,
Gerald Oskoboiny.
2002.

</dd>
<%=defref("XHTML")%>
<cite><a href="http://www.w3.org/TR/2000/REC-xhtml1-20000126/">XHTML 1.0: The Extensible HyperText Markup Language</a></cite>, 
W3C Recommendation, S. Pemberton <i lang="la" xml:lang="la">et
al.</i>, 26 January 2000.<br />
Available at: <tt>http://www.w3.org/TR/2000/REC-xhtml1-20000126</tt>
</dd>
<%=defref("XMLBASE")%>

    <cite><a href="http://www.w3.org/TR/2001/REC-xmlbase-20010627/">XML Base</a></cite>, J. Marsh, Editor, 
W3C Recommendation.  World Wide Web Consortium,  27 June 2001.  
This version of XML Base is <tt>http://www.w3.org/TR/2001/REC-xmlbase-20010627/</tt>. 
The <a href="http://www.w3.org/TR/xmlbase/">latest version of XML Base</a> is at 
<tt>http://www.w3.org/TR/xmlbase/</tt>.
  </dd>

<%=defref("XP")%>
<cite>
Extreme Programming Explained: Embrace Change</cite>,
Kent Beck.
5 Oct 1999.
Addison-Wesley. ISBN 0201616416.
</dd> 
<%=defref("Heinsohn et al.")%>
AI 68 (1994) pp367-397.
</dd> 
<%=defref("DIMACS")%>
<cite>Satisfiability Suggested Format</cite>
<code>challenge@dimacs.rutgers.edu</code>
Found at
<a href="ftp://dimacs.rutgers.edu/pub/challenge/satisfiability/doc/satformat.tex">
ftp://dimacs.rutgers.edu/pub/challenge/satisfiability/doc/satformat.tex</a>
May 8, 1993.
</dd> 
<%=defref("DL 98 Systems Comparison")%>
<a href="http://dl.kr.org/dl98/comparison/"><cite>DL Systems Comparison</cite></a>
at 
<a href="http://dl.kr.org/dl98/">1998 International Workshop on 
Description Logics (DL 98)</a>.
Peter F. Patel-Schneider, Ian Horrocks.
June, 1998.
</dd> 
</dl>
<% Iterator axit = refs.iterator(); 
   if ( axit.hasNext() ) {
%>
    <p class="todo">The following refs were not defined:</p>
    <ul>
<%  while ( axit.hasNext() ) {
%>     <li class="todo">[<%=(String)axit.next()%>]</li>
<% } %>
    </ul> 
<% } %>
</body> 
</html>
 
