/*
 * TestTypes.java
 *
 * Created on 19 September 2002, 11:21
 */

package wowg;
import java.util.*;
import com.hp.hpl.jena.util.iterator.ArrayIterator;

/**
 *
 * @author  jjc
 */
public class TestType {
    static public final TestType all[] = new TestType[]{
        new TestType("NotOwlFeatureTest","bad",null),
        new TestType("PositiveEntailmentTest","premises","conclusions"),
        new TestType("NegativeEntailmentTest","premises","nonconclusions"),
        new TestType("ImportsLevelTest","imports","main"),
        new TestType("ConsistencyTest","consistent",null),
        new TestType("InconsistencyTest","inconsistent",null),
        new TestType("MiscellaneousTest","first","second"),
        new TestType("TrueTest","conclusions",null),
        new TestType("OWLforOWLTest","conclusions",null),
    };
    static public final Iterator all() {
       return new ArrayIterator(all);
    }
    static public TestType lookup(String s) {
        for (int i=0; i<all.length; i++) 
            if (all[i].getName().equals(s))
                return all[i];
        return null;
    }
    public String getName() {
        return name;
    }
    
    public String getFirst() {
        return first;
    }
    public String getSecond() {
        return second;
    }
    String name;
    String first;
    String second;
    /** Creates a new instance of TestTypes */
    private TestType(String namex, String firstx, String secondx) {
        name = namex;
        first = firstx;
        second = secondx;
    }
    
}
