<?xml version="1.0" encoding="iso-8859-1"?>
<%@page contentType="text/html"
  import="java.util.*"
  import="java.io.*" 
  import="wowg.*"
  import="com.hp.hpl.jena.rdf.model.*" 
  
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html lang="en" xmlns="http://www.w3.org/1999/xhtml" >
<head>
<meta http-equiv="Content-Type" 
content="text/html; charset=iso-8859-1" />
 
  <meta name="rcsid"
  content="$Id: some.jsp,v 1.5 2003/04/17 22:15:16 jcarroll Exp $"  />

<title>Some (OWL) Test Cases</title> 
 
  <style type="text/css">
.Foo {
}
.TestTable {
  page-break-inside: avoid;
}
 .TestType {
 background-color: #d3d3d3;
    color: black;
 }  
.TestNumber {
    background-color: #d3d3d3;
    color: black;
 }
.TestDescriptionHead {
    background-color: #e8e8e8;
    color: black;
 }
.TestErrorsHead {
    background-color: #e8e8e8;
    color: black;
 }
.TestNamespacesHead {
    background-color: #e8e8e8;
    color: black;
 }
.TestPartHead {
    background-color: #e8e8e8;
    color: black;
 }
 .TestDescription {
    background-color: #ffec8b;
    color: black;
 }  
 .TestTriples {
    background-color: #85b9a5;
    color: black;
 } 
 .TestNamespaces {
    background-color: #85b9a5;
    color: black;
 } 
 .TestRDF {
    background-color: #c8c8f8;
    color: black;
 } 

.TestErrors {
    background-color: #ffe8e8;
    color: red;
 }
  .TestRDF pre {
    margin-left: 0em;
    margin-top: 0em;
    margin-bottom: 0em;
    font-family: monospace;
  }
  .TestTriples pre {
    margin-left: 0em;
    margin-top: 0em;
    margin-bottom: 0em;
    font-family: monospace;
  }
  .TestNamespaces pre {
    margin-left: 0em;
    margin-top: 0em;
    margin-bottom: 0em;
    font-family: monospace;
  }


.note  { margin-left: 2em; }

*.todo {
  color: red;
  font-style: italic; 
}

*.conformance {
  color: #850021;
  font-weight: bold;
  font-style: italic;
}

  </style>
<link rel="stylesheet" type="text/css"
 href="http://www.w3.org/StyleSheets/TR/base" />
</head>
<body>
<div class="head">

<h1>Some (OWL) Test Cases</h1>
<dl>
<dt>Latest editors snapshot:</dt>
<dd><a href="http://www.w3.org/2002/03owlt/editors-draft/snapshot">http://www.w3.org/2002/03owlt/editors-draft/snapshot</a></dd>
</dl>

</div>
<%! String named(String foo) {
      return "<code>"+foo +"<em>NNN</em>.rdf</code>";
    }
%>
<% Manifest approved = new Manifest("APPROVED",Zipper.getParameter(request,"which"));
   Manifest proposed = new Manifest("PROPOSED",Zipper.getParameter(request,"which"));
 // out = pageContext.pushBody();
  // out = pageContext.popBody();

%>

<%-- Test --%>

<%!
  boolean toc;
  String tocContent;
  int levels[];
  int lastLevel=-1; 
  int _lvl;
  String _anch;
  String _text;
  int _i;
  int appendix;
  boolean editorsDraft = true;
%>
 
<%!
   void closeToc(int lvl) {
     if ( lvl == lastLevel+1 ) {
         tocContent += "<ul class=\"toc\">";
          return;
    }
     String c = "</li>";
     for ( int j = lastLevel; j>lvl;j--)
       c = c + "</ul></li>";
     tocContent += c;
   }
   String head(int lvl,String anch,String text) {
      boolean nonumber = lvl == 0;
      lvl--;
      if ( lvl <= lastLevel && lvl >= 0 ) {
       levels[lvl]++;
      } else if ( lvl == lastLevel+1 ) {
        levels[lvl]=1;
     } else if ( lvl == -1 ) {
        lvl = 0;
     } else {
         return "<b>SCREW UP IN HEADER LEVELS: " + lastLevel + "; " + lvl + "</b>";
     }

     if ( toc ) {
       closeToc(lvl);
       lastLevel = lvl;
     String rslt = "<li class=\"tocline\"><a href='#"+anch+"'>";
     if (!nonumber) {
     if ( appendix > 0 )
         rslt += ((char)(levels[0]-appendix + 'A')) + ".";
      else
        rslt += levels[0] + ".";
     for (int i=1; i<=lvl; i++)
       rslt += levels[i]+".";
     }
     rslt += " "+ text + "</a>";

         tocContent += rslt;
        return "";
     } else {
     
     lastLevel = lvl;
     String rslt = "<h" + (lvl+1)+"><a id='"+anch+"' name='"+anch+"'>";
     if (!nonumber) {
     if ( appendix > 0 )
         rslt += ((char)(levels[0]-appendix + 'A')) + ".";
      else
        rslt += levels[0] + ".";
     for (int i=1; i<=lvl; i++)
       rslt += levels[i]+"."; 
     }
     rslt += " "+ text + "</a></h"+(lvl+1)+">";

     return rslt;
     }
  }

Set refs = new HashSet();
String repl(String s) {
return s.replace(' ','_').replace('/','_').replace('+','_');
}
String ref(String sss) {
   refs.add(sss);
   return "<a href=\"#ref-"+repl(sss)+"\">["+sss+"]</a>";
}
String defref(String sss) {
    String rslt = "<dt><a name=\"ref-"+repl(sss)+"\" id=\"ref-"+repl(sss)+"\" >["
            +sss+"]</a></dt><dd>";
    if ( !refs.contains(sss) ) {
         rslt = rslt + "Not referenced. ";
   } else {
        refs.remove(sss);
   }
   return rslt;
}
String internal(String anch, String sss) {
   return "<a href=\"#"+anch+"\">"+sss+"</a>";
}
%>

<%levels = new int[5];
 lastLevel=-1;
 appendix = -1;
%>



<%// <ul class="toc">
// Variables used during test case output.
// Setup variables
   Manifest tests;  // The test we select from.
   boolean useRDFXML;  // or NTriple
   boolean byFunction; // or byIssue
   boolean areNormative = false;
   String prefix;    // used in fragment identifiers
   String testTag = null;   
   Set simpleAnchors = new HashSet();

// utility variables
   Iterator it;
   Map testsBy;
%>
<%
  //if ( true )
  //{ final PrintWriter out = new PrintWriter(new OutputStreamWriter(new OutputStream(){
  //  public void write(int i) {}
  //}));
  toc = false;
 // } 
%>
<%--
<%=ctxt.getString()%>
--%> 
<%levels = new int[5];
 lastLevel=-1;
 appendix = -1;
 simpleAnchors = new HashSet();
%>
<hr /> 

<%
    useRDFXML = true;
    prefix="approved";
    tests = approved;
    boolean showRDFXML = true;
    boolean showTriples = true;
%>
<%=head(1,prefix,"Approved Tests")%>
<%@include file="tests1.jsp" %>
<%
    useRDFXML = true;
    prefix="proposed";
    tests = proposed;
    showRDFXML = true; 
    showTriples = true;
%>
<%=head(1,prefix,"Proposed Tests")%>

<%@include file="tests1.jsp" %>

</body> 
</html>
