<%@page import="com.hp.hpl.jena.vocabulary.RDFS"%>
<%-- This page is for the content of a miscellaneous/extra-credit/dl
    test subsection. --%>
<%
  it = testsBy.keySet().iterator();
  while (it.hasNext()) {
     Resource r = (Resource)it.next();
    String frag = r.getURI().substring(r.getURI().lastIndexOf('#')+1);
    String name = "[["+frag+"]]";
    String outerAnchor = frag;
    int id = 0;
    boolean suppress = false;
    if ( frag.equals("misc-000-guide") ) {
        id = 1000;
        name = "Examples from the OWL Guide";
        suppress = true;
    } else if ( frag.equals("misc-100-syntax") ) {
       id = 1100;
       name = "Detailed OWL Lite and OWL DL Syntax";
    } else if ( frag.equals("misc-200-xmlliteral") ) {
       id = 1200;
       name = "Concerning rdf:XMLLiteral";
    }  else if ( frag.equals("misc-300-annotations") ) {
       id = 1300;
       name = "Annotations";
    } else if ( frag.equals("dl-000-satisfiability") ) {
       id = 2000;
       name = "Extended Satisfiability Tests";
    } else if ( frag.equals("dl-100-heinsohn") ) {
       id = 2100;
       name = "Heinsohn's Tests";
    } else if ( frag.equals("dl-200-instance") ) {
       id = 2200;
       name = "DL 98 Instance Tests";
    } else if ( frag.equals("dl-500-SAT") ) {
       id = 2500;
       name = "The 3 SAT Problem";
    } else if ( frag.equals("dl-900-arith") ) {
       id = 2900;
       name = "Extended Cardinality Testing";
    } else if ( frag.equals("extra-000-arithmetic") ) {
       id = 3000;
       name = "Arithmetic in OWL";
    }
%>
   <%  testTag = prefix+"-"+frag; 
   %>
   <% if ( !simpleAnchors.contains(outerAnchor) ) {
         simpleAnchors.add(outerAnchor);
   %>
      <a name="<%=outerAnchor%>" id="<%=outerAnchor%>"><!-- --></a>
   <%
      }
   %>
   <%= head(3,testTag,name ) %>
<% switch ( id ) {
   case 1000:
%>
<p>These tests are taken from the <%=ref("OWL Guide")%>.</p>
<% break;
  case 1100:
%>
<p>These tests illustrate detailed points about the 
<a href="http://www.w3.org/TR/owl-semantics/mapping#4.1">mapping rules</a>
in <%=ref("OWL Semantics and Abstract Syntax")%>,
and the syntax of OWL Lite and OWL DL.</p>
<% break;
  case 1200:
%>
<p>These tests illustrate the use of <code>rdf:XMLLiteral</code>.</p>
<% break;
  case 1300:
%>
<p>These tests concern the semantics of annotations.</p>
<% break;
  case 2000:
%>
<p>These are general satisfiability tests that are intended to
test the interaction of role hierarchies, disjoint concepts and other
things within an OWL reasoner.</p>
<% break;
  case 2100:
%>
<p>See <%=ref("Heinsohn et al.")%>.</p>
<% break;
  case 2200:
%>
<p>These tests have been ported from the DL 98 tests <%=ref("DL 98 Systems Comparison")%>.</p>
<% break;
  case 2500:
%>
<p>These tests show how the classic 3 SAT problem can be encoded in OWL DL.
The comment before each test gives the 3 SAT problem in the <%=ref("DIMACS")%> 
format.
</p>
<% break;
  case 3000:
%>
<p>Tests that show the relationship between OWL and simple arithmetic.</p>
<% break;
   case 0:
%>
<p class="todo">A description of these tests needs to be added.</p>
<% }
%>
<%@include file="tests3.jsp"%>
<%
    }
%>
